# -*- coding: utf-8 -*-
"""
Created on Mon Jan  1 21:30:50 2024

@author: SA-Lenovo
"""
import time
import asyncio

BOUND = 10**6

def collatz(n):
    steps = 0
    while n > 1:
        if n % 2:
            n = n * 3 + 1
        else:
            n = n / 2     
        steps += 1
    return steps


async def length_counter(target):
    count = 0
    for i in range(2, BOUND):
        if collatz(i) == target:
            count += 1
        # allow other tasks to run for a moment
        #await asyncio.sleep(0)
    return count


def get_input(prompt):
    while True:
        n = input(prompt)
        try:
            n = int(n)
        except ValueError:
            print("Value must be an integer.")
            continue
        if n <= 0:
            print("Value must be positive.")
        else:
            return n


async def main():
    print("Collatz Sequence Counter")
    
    target = get_input("Collatz sequence length to search for: ")
  
    print(f"Searching in range 1-{BOUND}...")     
    
    length_counter_task = asyncio.create_task(length_counter(target))
    
    
    count = await length_counter_task
    
    print(f"Your target number {target} occuried {count} times") 
    
        
if __name__ == "__main__":
    # Start timer
    start_time = time.time()
    asyncio.run(main())
    end_time = time.time()

    # Calculate elapsed time
    elapsed_time = end_time - start_time
    print("Elapsed time: ", elapsed_time) 
        
