# -*- coding: utf-8 -*-
"""
Created on Mon Jan  1 19:25:26 2024

@author: SA-Lenovo
"""
import time

BOUND = 10**6

def collatz(n):
    steps = 0
    while n > 1:
        if n % 2:
            n = n * 3 + 1
        else:
            n = n / 2     
        steps += 1
    return steps


def length_counter(target):
    count = 0
    for i in range(2, BOUND):
        if collatz(i) == target:
            count += 1
    return count


def get_input(prompt):
    while True:
        n = input(prompt)
        try:
            n = int(n)
        except ValueError:
            print("Value must be an integer.")
            continue
        if n <= 0:
            print("Value must be positive.")
        else:
            return n


def main():
    print("Collatz Sequence Counter")
    target = get_input("Collatz sequence length to search for: ")
    print(f"Searching in range 1-{BOUND}...")     
    
    count = length_counter(target)
    print(f"Your target number {target} occuried {count} times") 
    

        
if __name__ == "__main__":
    # Start timer
    start_time = time.time()
    main()
    end_time = time.time()

    # Calculate elapsed time
    elapsed_time = end_time - start_time
    print("Elapsed time: ", elapsed_time) 
        
